'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utility = require('../utility');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (hexadecimal) {
  var percent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
  var css = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  if (hexadecimal) {
    var hex = (0, _utility.hashChar)(hexadecimal);

    if ((0, _utility.aHex)(hex)) {
      if (percent === null || typeof percent === 'boolean') {
        if (hex.length === 3) {
          hex = [].concat(_toConsumableArray(hex)).map(function (c) {
            return c.repeat(2);
          }).join('');
        }

        var bigint = parseInt(hex, 16);
        var rgb = [bigint >> 16 & 255, bigint >> 8 & 255, bigint & 255];

        if (percent === true) {
          rgb = rgb.map(function (val) {
            return Number((val * 100 / 255).toFixed(percent ? 2 : 0));
          });
        }

        if (css === true) {
          if (percent === true) {
            rgb = (0, _utility.formatRgb)(rgb, true);
          } else {
            rgb = (0, _utility.formatRgb)(rgb);
          }
        }

        return rgb;
      }

      throw new Error('Percent must be boolean');
    }

    throw new Error('Hex must be a string or number');
  }
  throw new Error('Something wrong with given hex value');
};